#!/bin/sh
. ./login.sh

LogInLogic
GetOperatorName
if [ -z "$logOper" ] || [ "$logOper" = "10" ]; then

if [ "$action" = "Override+IP+Details" ]; then
    export action="Set+IP+Details"
fi
	case $action in
		Set+Scan+Mode)
			case $scan in
				Auto-scan)
					RESULT="Bus scan mode set to automatic"
					SCAN=1
					;;
				Manual-scan)
					RESULT="Bus scan mode set to manual"
					SCAN=0
					;;
				esac
				ascu_db_trans -db Site.db -f 12 -w "12	$SCAN"
				qt /usr/bin/aisg_command
			;;
		Change+Name)
			if [ -z "$site" ]; then
				RESULT="Please enter a new name"
			else
				SITE=`xlate $site`
				ascu_db_trans -db Site.db -f 1 -w "1	$SITE"
				RESULT="Site name changed to $SITE"
			fi
			;;
		Set+Date+and+Time)
			if [ -z "$minute" ]; then
				qt date -u "$year.$month.$day-$hour:$minuteten$minuteunit"
			else
				qt date -u "$year.$month.$day-$hour:$minute"
			fi
			/sbin/hwclock -w    # set hardware clock to the system time
			RESULT="Date & Time adjusted"
			#resync actuators - removed 8/20/14 SMH
			#QUERY_STRING="command=249&subset=Device&name=All"
			#qt aisg_command &
			;;
		Set+IP+Address)
			if [ "$ipaddr" = "10.254.254.254" ]; then
			  RESULT="ILLEGAL IP ADDRESS!"
			else
			  if [ -z "$override" ]; then
				ascu_db_trans -db Site.db -f 6 -w "6	$ipaddr"
				echo $ipaddr > /StaticIP.txt
			  else
				ascu_db_trans -db Site.db -f 6 -w "6	$override"
				echo $override > /StaticIP.txt
			  fi
			  save >>/dev/null
			RESULT="IP address $ipaddr  will be updated at the next reboot"
			fi
			;;
		Set+IP+Details)
			  if [ -z "$override" ]; then
			    echo >>/dev/null
            		  else
	                    export ipaddr=$override
            		  fi
			  if [ "$dhcp" = "on" ]; then
				if [ -z "$hostnm" ]; then
					RESULT="Error - DHCP requires a Hostname"
				else
				   echo $hostnm > /HostName.txt
				   if [ -f /StaticIP.txt ]; then
					rm /StaticIP.txt
				   fi
				   if [ -z "$router" ]; then
					ascu_db_trans -db Site.db -f 10 -r
					if [ -f /Route.txt ]; then
						rm /Route.txt
					fi
				   else
					ascu_db_trans -db Site.db -f 10 -w "10	$router"
					echo $router > /Route.txt
				   fi
				   if [ -z "$netmask" ]; then
					ascu_db_trans -db Site.db -f 9 -r
					if [ -f /NetMask.txt ]; then
						rm /NetMask.txt
					fi
				   else
				        ascu_db_trans -db Site.db -f 9 -w "9	$netmask"
					echo $netmask > /NetMask.txt
				   fi
				   save >>/dev/null
				fi
 			  else
				RESULT="IP details will be updated at the next reboot"
				if [ -z "$ipaddr" ]; then
					RESULT="Error - Please enter a Static IP address"
				else
					ascu_db_trans -db Site.db -f 6 -w "6	$ipaddr"
					echo $ipaddr > /StaticIP.txt
				fi
				if [ -z "$netmask" ]; then
					RESULT="Error - Please enter a Network Mask"
				else
				        ascu_db_trans -db Site.db -f 9 -w "9	$netmask"
					echo $netmask > /NetMask.txt
				fi
				if [ -z "$router" ]; then
					ascu_db_trans -db Site.db -f 10 -r
					if [ -f /Route.txt ]; then
						rm /Route.txt
					fi
				else
					ascu_db_trans -db Site.db -f 10 -w "10	$router"
					echo $router > /Route.txt
				fi
				if [ -z "$hostnm" ]; then
					if [ -f /HostName.txt ]; then
						rm /HostName.txt
					fi
				else
					echo $hostnm > /HostName.txt
				fi

				save >>/dev/null
			  fi
			;;
		Set+MAC+Address)
			ascu_db_trans -db Site.db -f 7 -w "7	$macaddr"
			RESULT="Ethernet MAC address will be updated at the next reboot"
			;;
		Save+Bus+Config)
			if [ "$externalBusPower" = "on" ]; then
				echo $externalBusPower >/var/ascu/ExternalBusPwr.txt
			else
				rm -f /var/ascu/ExternalBusPwr.txt
			fi
			;;
		Save+Relay+Config)
			if [ "$relaysAreNC" = "on" ]; then
				echo $relaysAreNC >/var/ascu/RelaysAreNC.txt
			else
				rm -f /var/ascu/RelaysAreNC.txt
			fi
			;;
		Clear+Locked+Data+Ports)
			echo "1" >/tmp/ClearPortLocks.txt
			;;
	esac
else
echo Feature is unavailable for this operator.
cat <<EOF
          <tr> <td>&nbsp;</td></tr>
          <tr>
            <td align=center>
                <input name="btnClose" type="button" id="btnClose" value="Close" onclick="parent.location='/cgi-bin/index.cgi'">
            </td>
          </tr>
EOF
fi
cat << EOF


