#!/bin/sh

ARGC=1
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiDevFuncs.sh

echo $QUERY_STRING
cat <<EOF
Content-type: text/html
Expires: Wed, 21 Aug 1968 00:01:00 GMT

<html>
<head>
<title>Upgrade Progress</title>
<link rel=stylesheet href="/ascu.css" type="text/css">
</head>
<body>
<h3>Upgrade Progress</h3>
Waiting for command to begin...<br>
<script type="text/javascript">
    opener.document.getElementById("menubar").disabled = true;
</script>
EOF
	if [ "$action" = "Upload+File+to+Device" ]; then
		FAIL="Firmware installation was unsuccessful"
		if [ -z "$device" ]; then
			echo "No devices were selected <br>"
		else
			if [ -z "$type" ]; then
				echo "A file type must be specified <br>"
			else
				if [ -z "$url" ]; then
					echo "A valid URL for the file must be provided <br>"
				else
					URL1=`echo $url | sed "s/%3A/:/g;s/%2F/\//g"`
					URL=`echo $URL1 | sed "s/ftp:\/\///"`
					file=`basename $URL`
					if [ -n "$username" ]; then
						USER="$username:$password@"
					else
						USER=""
					fi
					RESULT=`wget -O /tmp/$file -q ftp://$USER$URL 2>&1`
					if [ $? = 1 ]; then
						echo "Unable to access ftp://$URL" '<br>'
                    else
                        echo "File retrieved.<br>"
					fi
				fi
			fi
		fi
		if [ -z "$RESULT" ]; then
			export QUERY_STRING="name=All&subset=Device&file=$file&command=50&$QUERY_STRING"
			cat <<-EOF
						<H3>Upload File to Device</H3><br>
                        Waiting on download...<br>
                        Download can take several minutes.<br>
                        <br>
EOF
            /usr/bin/aisg_command -l -b "&nbsp;" -e "&nbsp;" -s "&nbsp;"
			cat <<-EOF
                        <br>Done.<br>
                        Note:  You may see 'Disconnected' as the result.<br>  This is normal.<br>&nbsp;<br>
			EOF
		else
			echo $RESULT
			echo $FAIL
		fi
	fi

cat <<EOF
Please wait...<br>
EOF
sleep 10
cat<<EOF
<script type="text/javascript">
    opener.workerhog.document.open();
    opener.workerhog.document.write("Upgrade finished!<BR>");
    opener.workerhog.document.close();
    opener.document.getElementById("menubar").disabled = false;
    opener.menus[0].disabled = true;
    opener.menus[1].disabled = true;
    opener.menus[2].disabled = true;
    opener.menus[3].disabled = true;
    opener.location.reload(true);
</script>
<input type=button value="Close Window" onClick="window.close(this)" class=button style="width: 110px"><br>
</body>
</html>
    
