#!/bin/sh
ARGC=1
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiSysFuncs.sh
. ./cgiDevFuncs.sh

cat <<EOF
Content-type: text/html
Expires: Wed, 21 Aug 1968 00:01:00 GMT

<html>
<head>
<title>Configuration Change In Progress</title>
<link rel=stylesheet href="/ascu.css" type="text/css">
</head>
<body>

EOF
. ./login.sh
GetOperatorName

if [ -z "$logOper" ] || [ "$logOper" = "10" ]; then
cat <<EOF

<h3>Configuration Change</h3>
Please wait while the system executes a configuration change.<br>
EOF
export RESULT="0"
case $action in
   Rename+Device)
           export DESCRIPTION="rename $name as $handle"
           echo Renaming $name as $handle '<br>'
			NEWNAME=`xlate $handle`
			NAME=`devname $name`
			EXIST=`ascu_db_trans -db Handle.db -f "	$NEWNAME"`
            echo "<! 1 >"
			if [ -z "$EXIST" ]; then
				ascu_db_trans -db Handle.db -f "$name" -w "$name	$NEWNAME"
				LIST="Sector.db Group.db Band.db"
				for DB in $LIST ; do
					ascu_db_trans -db $DB -f "	$NAME" -w "*	$NEWNAME"
				done
				echo="Device $NAME renamed to $NEWNAME <br>"
			else
				echo "A device named $NEWNAME already exists <br>"
                export RESULT="1"
                sleep 5
			fi
            echo "<! 2 >"
			;;
   Remove+Device)
           export DESCRIPTION="remove $name"
           echo Removing $name '<br>'
			# Get the device name 1st!
			NAME=`devname $name`
			# Tell aisg_manager
			aisg_command
   
            echo Device no longer being polled. '<br>'
			# Databases with device# in 1st field
			ascu_db_trans -db Handle.db -f "$name" -r
			ascu_db_trans -db Device.db -f "$name" -r -E
            
			# Databases with device ID in last field
			LIST="Sector.db Group.db Band.db"
			for DB in $LIST ; do
				ascu_db_trans -db $DB -f "	$NAME" -r
			done
            echo Device removed from databases. '<br>'
   ;;
   Configure+Device)
       export DESCRIPTION="add $vendor$serial"
       echo Adding $vendor$serial. '<br>'
       /usr/bin/aisg_command -l -b "&nbsp;" -e "<br>" -s "&nbsp;"       
       export RESULT=$?
       if [ "$RESULT" = "0" ]; then
        echo 'Success' '<br>'
       else
        echo 'Failed' '<br>'
        cat <<EOF
<h3>Failure</h3>
The device you added did not answer.  Please check the serial number and all connections.<br>
EOF
       fi       
   ;;
   AISG+2+Reset)
       export DESCRIPTION="broadcast AISG 2.0 Reset"
       echo Broadcasting AISG 2.0 Reset '<br>'
       echo '<br>'
       echo Note: Andrew TMAs that have changed AISG modes should be deleted and rescanned for proper representation. '<br>'
       echo '<br>'
       export QUERY_STRING="action=Reset+Device&name=All"
       /usr/bin/aisg_command
       export RESULT=$?
       if [ "$RESULT" = "0" ]; then
        echo 'Success' '<br>'
       else
        echo 'Failed'
       fi
   ;;
   AISG+2+Revert)
       export DESCRIPTION="revert Andrew dual-mode devices to AISG 1.1"
       echo Reverting Andrew dual-mode devices to AISG 1.1 '<br>'
       echo '<br>'
       echo Note: Andrew TMAs that have changed AISG modes should be deleted and rescanned for proper representation. '<br>'
       echo '<br>'
       export QUERY_STRING="action=Revert+Device&name=All"
       /usr/bin/aisg_command
       export RESULT=$?
       if [ "$RESULT" = "0" ]; then
        echo 'Success' '<br>'
       else
        echo 'Failed'
       fi
   ;;
   AITM+To+MultiSingleRET)
       export DESCRIPTION="set all AITM devices to multiple-single RET mode"
       echo Setting all AITM devices to multiple-single RET mode '<br>'
       echo '<br>'
       echo Note: Andrew AITMs that have changed modes should be deleted and rescanned for proper representation. '<br>'
       echo '<br>'
       export QUERY_STRING="action=AITM+To+MultiSingleRET&name=All"
       /usr/bin/aisg_command
       export RESULT=$?
       if [ "$RESULT" = "0" ]; then
        echo 'Success' '<br>'
       else
        echo 'Failed'
       fi
   ;;
   AITM+To+MultiRET)
       export DESCRIPTION="set all AITM devices to multiRET mode"
       echo Setting all AITM devices to multiRET mode '<br>'
       echo '<br>'
       echo Note: Andrew AITMs that have changed modes should be deleted and rescanned for proper representation. '<br>'
       echo '<br>'
       export QUERY_STRING="action=AITM+To+MultiRET&name=All"
       /usr/bin/aisg_command
       export RESULT=$?
       if [ "$RESULT" = "0" ]; then
        echo 'Success' '<br>'
       else
        echo 'Failed'
       fi
esac
echo '<br>'
if [ "$RESULT" = "0" ]; then
cat <<EOF
<script type="text/javascript">
    opener.workerhog.document.open();
    opener.workerhog.document.writeln("Successful. ");
    opener.workerhog.document.close();
    opener.location.reload(true);
    
</script>
EOF
else
cat <<EOF
<script type="text/javascript">
    opener.workerhog.document.open();
    opener.workerhog.document.writeln("Failure to $DESCRIPTION ");
    opener.workerhog.document.close();
</script>
EOF

fi

cat <<EOF
<input type=button value="Close Window" onClick="window.close(this)" class=button style="width: 110px"><br>
</body>
EOF
else
echo Feature is unavailable for this operator.'<br>'
cat <<EOF
<script type="text/javascript">
    opener.workerhog.document.open();
    opener.workerhog.document.writeln("Operation not performed.");
    opener.workerhog.document.writeln("Administrative session has timed out.");
    opener.workerhog.document.close();
    opener.workerhog.document.reload(true);
</script>
<input type=button value="Close Window" onClick="window.close(this)" class=button style="width: 110px"><br>
EOF
fi
cat <<EOF
</html>
EOF
