#!/bin/sh

BACKLINK=$HTTP_REFERER
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiSysFuncs.sh

REFR="/cgi-bin/index.cgi"
export META="<META HTTP-EQUIV=REFRESH CONTENT=\"65; URL=$REFR\">"
export TARGET=ANDREW

./header2.sh "Software Configuration Action Result"

cat << EOF
   <div class="box">
     <table cellspacing="0" width="100%">
       <tbody>
         <tr>
           <td><label>Command Response: </label></td>
         </tr>
       </tbody>
     </table>
   </div>
EOF

export LOGGER="Misc.tar"

. ./login.sh
LogInLogic
GetOperatorName
if [ -n "$logOper" ] && [ "$logOper" != "10" ]; then
				RESULT="Unable to reboot"
				FAIL="Feature is unavailable for this operator."
elif [ "$useftp" = "Yes" ]; then
				TITLE="System Firmware Upload"
				if [ -z "$filename" ]; then
					RESULT="A valid firmware or antenna file must be provided"
				else
					FILE=`basename $filename`
					ULTYPE=`echo $FILE | sed "s/.......//;s/_.*//;s/^.*\(..\)$/\1/"`
					VENDOR=`echo $FILE | sed "s/....//;s/-.*//"`
					FILETYPE=`echo $FILE | sed "s/.*\.//"`
					if [ "$ULTYPE" = "AT" ]; then
						if [ "$VENDOR" = "AN" ]; then
							DEST="/tmp/$filename"
							export FINALDEST="Antenna.db"
							export LOGGER="Antenna.tag"
						else
							DEST="/tmp/$filename"
							export FINALDEST="Antenna$VENDOR.db"
							export LOGGER="Antenna$VENDOR.tag"
						fi
					elif [ "$FILETYPE" = "ar1t" ]; then
						DEST="/tmp/$filename"
						export FINALDEST="ACRET1-TABLE.ar1t"
						export LOGGER="ACRET1.tag"
					else
						DEST="/tmp/$filename"
						export LOGGER="Firmware.tag"
						export FINALDEST="swupdate.tar"
					fi
				fi
elif [ -z "$action" ]; then
	echo "No action indicated"
else
	case $action in
		Install+System+Firmware)
			BUSY=`syslock boot $REMOTE_ADDR`
			if [ -z "$BUSY" ]; then
				TITLE="System Firmware Upload"
				if [ -z "$url" ]; then
					RESULT="A valid URL for the firmware file must be provided"
				else
					URL1=`echo $url | sed "s/%3A/:/g;s/%2F/\//g"`
					URL=`echo $URL1 | sed "s/ftp:\/\///"`
					ADDR=`echo $URL | sed "s@/.*@@"`
					FILE=`basename $URL`
					ULTYPE=`echo $FILE | sed "s/.......//;s/_.*//;s/^.*\(..\)$/\1/"`
					VENDOR=`echo $FILE | sed "s/....//;s/-.*//"`
					FILETYPE=`echo $FILE | sed "s/.*\.//"`
					if [ "$ULTYPE" = "AT" ]; then
						if [ "$VENDOR" = "AN" ]; then
							DEST="/tmp/Antenna.db"
							export FINALDEST="Antenna.db"
							export LOGGER="Antenna.tag"                        
							if [ -z `echo $FILE | sed -n "/.*.ascu\$/p"` ]; then
								URL=""
							else
								if [ -n "$username" ]; then
									USER="$username:$password@"
								else
									USER=""
								fi
							fi
						else
							DEST="/tmp/Antenna$VENDOR.db"
							export FINALDEST="Antenna$VENDOR.db"
							export LOGGER="Antenna$VENDOR.tag"                        
							if [ -z `echo $FILE | sed -n "/.*.ascu\$/p"` ]; then
								URL=""
							else
								if [ -n "$username" ]; then
									USER="$username:$password@"
								else
									USER=""
								fi
							fi
						fi
					elif [ "$FILETYPE" = "ar1t" ]; then
						DEST="/tmp/$FILE"
						export FINALDEST="ACRET1-TABLE.ar1t"
						export LOGGER="ACRET1.tag"
						if [ -n "$username" ]; then
							USER="$username:$password@"
						else
							USER=""
						fi
					else
						DEST="+"
						export LOGGER="Firmware.tag"
						export FINALDEST="swupdate.tar"
						if [ -z `echo $FILE | sed -n "/.*.tar\$/p"` ]; then
							URL=""
						else
							if [ -n "$username" ]; then
								USER="$username:$password@"
							else
								USER=""
							fi
						fi
					fi
				fi
			else
				RESULT="Unable to install firmware"
				FAIL="Installation lock held by $BUSY"
			fi
			;;
		Reboot)
			  IPADDR=`getaddr 6`
			  BUSY=`syslock boot $REMOTE_ADDR`
			  if [ -z "$BUSY" ]; then
				TITLE="System Reboot"
				#echo > /var/run/reboot
				RESULT="Rebooting - please wait"
				FAIL="Reboot in approx 60 seconds"
				PORT=80
				if [ -z "$IPADDR" ]; then
					if [ -f /StaticIP.txt ]; then
						IPADDR=`cat /StaticIP.txt`
					fi
				fi
				if [ -z "$IPADDR" ]; then
					REFR="/cgi-bin/index.cgi"
				else
					REFR="http://$IPADDR:$PORT/cgi-bin/index.cgi"
				fi
				export META="<META HTTP-EQUIV=REFRESH CONTENT=\"65; URL=$REFR\">"
				fastboot.sh &
			  else
				RESULT="Unable to reboot"
				FAIL="Firmware installation lock held by $BUSY"
			  fi
			;;
		Clear+Stale+Lock)
			TITLE="Clear Lock"
			if [ -f /var/lock/boot ]; then
				RESULT="Lock held by `cat /var/lock/boot`"
				unlock boot
				FAIL="Lock cleared"
			else
				RESULT="No stale lock found"
				FAIL=" "
			fi
			;;
	esac
fi



echo "<pre>"
if [ -z "$FAIL" ]; then
	FAIL="Firmware installation was unsuccessful"
fi
if [ "$useftp" = "Yes" ]; then
		#echo "In USEFTP logic, ULTYPE=$ULTYPE, DEST=$DEST, FILE=$FILE, FILETYPE=$FILETYPE, FINALDEST=$FINALDEST, FILENAME=$filename"
		if [ "$ULTYPE" = "AT" ]; then	#this is an antenna table download
			if [ -f "$DEST" ]; then
                		echo "<tr><td align=center>$FINALDEST</td><td align=center>$filename</td><td align=center>`date`</td></tr>" >/var/ascu/$LOGGER
				mv $DEST /var/ascu/$FINALDEST
				echo -n > /var/run/Dirty.db
				RESULT="<b>Antenna table installed successfully</b>"
				FAIL=""
				kill `cat /var/run/snmpd.pid`
			else
				FAIL="Antenna table installation was unsuccessful"
			fi
		elif [ "$FILETYPE" = "ar1t" ]; then    #this is an Accuret table
			if [ -f "$DEST" ]; then
                		echo "<tr><td align=center>$FINALDEST</td><td align=center>$filename</td><td align=center>`date`</td></tr>" >/var/ascu/$LOGGER
				mv $DEST /var/ascu/$FINALDEST
				echo -n > /var/run/Dirty.db
				RESULT="<b>AccuRET antenna table installed successfully</b>"
				FAIL=""
				kill `cat /var/run/snmpd.pid`
			else
				FAIL="AccuRET antenna table installation was unsuccessful"
			fi
		elif [ "$FILETYPE" = "tar" ]; then	#this is a firmware download
			if [ -f "$DEST" ]; then
                		echo "<tr><td align=center>$FILE</td><td align=center>$filename</td><td align=center>`date`</td></tr>" >/var/ascu/$LOGGER
				mv $DEST /var/ascu/uploads/uploads/$FINALDEST
				RESULT="<b>Firmware downloaded successfully</b>"
				FAIL="Downloaded firmware will be installed at the next reboot"
			else
				FAIL="Firmware download was unsuccessful"
			fi
		else
			FAIL="File type was not recognized. Firmware download was unsuccessful."
			rm $DEST
		fi

elif [ -z "$URL" ]; then
	if [ -z "$RESULT" ]; then
		RESULT="A valid URL for the firmware file must be provided"
	fi
	if [ -z "$BUSY" ]; then
		unlock boot
	fi
else
	START=`date +%s`
	STATUS=`ascu_db_trans -db Error.db -f "	DOWNLOAD_STATUS" | cut -f 1`
	setstat -d 0 -s $STATUS
	echo "Transferring firmware from ftp://$URL"
	RESULT=`wget -O $DEST ftp://$USER$URL 2>&1`
	if [ $? = 0 ]; then
		let DELTA=`date +%s`-$START
		if [ "$ULTYPE" = "AT" ]; then	#this is an antenna table download
			if [ -f "$DEST" ]; then
                		echo "<tr><td align=center>$FINALDEST</td><td align=center>$URL</td><td align=center>`date`</td></tr>" >/var/ascu/$LOGGER
				BYTES=`ls -l $DEST | sed "s/  */	/g" | cut -f 5`
				echo "Transferred $BYTES bytes in $DELTA seconds"
				mv $DEST /var/ascu
				echo -n > /var/run/Dirty.db
				RESULT="<b>Antenna table installed successfully</b>"
				FAIL=""
				kill `cat /var/run/snmpd.pid`
			else
				FAIL="Antenna table installation was unsuccessful"
			fi
		elif [ "$FILETYPE" = "ar1t" ]; then    #this is an Accuret table
			if [ -f "$DEST" ]; then
                		echo "<tr><td align=center>$FINALDEST</td><td align=center>$URL</td><td align=center>`date`</td></tr>" >/var/ascu/$LOGGER
				BYTES=`ls -l $DEST | sed "s/  */	/g" | cut -f 5`
				echo "Transferred $BYTES bytes in $DELTA seconds"
				mv $DEST /var/ascu/$FINALDEST
				echo -n > /var/run/Dirty.db
				RESULT="<b>AccuRET antenna table installed successfully</b>"
				FAIL=""
				kill `cat /var/run/snmpd.pid`
			else
				FAIL="AccuRET antenna table installation was unsuccessful"
			fi
		elif [ "$FILETYPE" = "tar" ]; then	#this is a firmware download
			if [ -f "$DEST" ]; then
                		echo "<tr><td align=center>$FILE</td><td align=center>$URL</td><td align=center>`date`</td></tr>" >/var/ascu/$LOGGER
				BYTES=`ls -l $DEST | sed "s/  */	/g" | cut -f 5`
				echo "Transferred $BYTES bytes in $DELTA seconds"
				mv $DEST /var/ascu/uploads/uploads/$FINALDEST
				RESULT="<b>Firmware downloaded successfully</b>"
				FAIL="Downloaded firmware will be installed at the next reboot"
			else
				FAIL="Firmware download was unsuccessful"
			fi
		fi
	else
		echo 'Result:'
		echo $RESULT
		echo 'Retry download<br>'
	fi

	setstat -d 0 -c $STATUS
	unlock boot

	export QUERY_STRING="action=Wake"
	TEMP=`aisg_command`
	sleep 2
fi

echo $RESULT
echo
echo $FAIL
cat <<EOF
</pre>
<a href="/cgi-bin/atc300SoftwareConfig.cgi">Back</a>
EOF
if [ -z "$logOper" ]; then
    cat menubar.html
else 
  if [ "$logOper" = "10" ]; then
    cat menubar_admin.html
  else
    cat menubar_oper.html
  fi
fi
cat <<EOF
</body>
</html>
EOF

