#!/bin/sh

BACKLINK=$HTTP_REFERER
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiSysFuncs.sh
./header2.sh "Software Configuration Action Result"

/www/cgi-bin/rfcupload
export RFCUPLOADSTATUS=$?

cat << EOF
   <div class="box">
     <table cellspacing="0" width="100%">
       <tbody>
         <tr>
           <td><label>Command Response: </label></td>
         </tr>
       </tbody>
     </table>
   </div>
EOF

export LOGGER="Misc.tag"

if [ -z "$action" ]; then
	RESULT=""
else
	case $action in
		Install+System+Firmware)
			BUSY=`syslock boot $REMOTE_ADDR`
			if [ -z "$BUSY" ]; then
				TITLE="System Firmware Upload"
   				URL1=`echo $filename | sed "s/%3A/:/g;s/%2F/\//g"`
   				URL=`echo $URL1 | sed "s/ftp:\/\///"`
   				ADDR=`echo $URL | sed "s@/.*@@"`
   				export FILE=`basename $URL`
   				ULTYPE=`echo $FILE | sed "s/.......//;s/_.*//"`
                                VENDOR=`echo $FILE | sed "s/....//;s/-.*//"`
   				if [ "$ULTYPE" = "AT" ]; then
                                  if [ "$VENDOR" = "AN" ]; then
                                    export VENDOR=""
                                  fi
 	 		          DEST="/tmp/Antenna$VENDOR.db"
                                  export FINALDEST="Antenna$VENDOR.db"
                                  export LOGGER="Antenna$VENDOR.tag"
   				else
   				  DEST="+"
                                  export LOGGER="Firmware.tag"
                                  export FINALDEST="Firmware.tag"
   				fi
			else
				RESULT="Unable to install firmware"
				FAIL="Installation lock held by $BUSY"
			fi
			;;
	esac
fi


echo "<pre>"
	START=`date +%s`
	STATUS=`ascu_db_trans -db Error.db -f "	DOWNLOAD_STATUS" | cut -f 1`
	#echo "5,$$" >/var/run/Status.set
	setstat -d 0 -s $STATUS
	cp /tmp/$FILE $DEST
    rm /tmp/$FILE
	if [ $? = 0 ]; then
		let DELTA=`date +%s`-$START
		if [ "$ULTYPE" = "AT" ]; then
			if [ -f "$DEST" ]; then
                echo "<tr><td align=center>$FINALDEST</td><td align=center>$URL</td><td align=center>`date`</td></tr>" >/var/ascu/$LOGGER
				BYTES=`ls -l $DEST | sed "s/  */	/g" | cut -f 5`
				echo "Transferred $BYTES bytes in $DELTA seconds"
				mv $DEST /var/ascu
				echo -n > /var/run/Dirty.db
				RESULT="<b>Antenna table installed successfully</b>"
				FAIL=""
			else
				FAIL="Antenna table installation was unsuccessful"
			fi
		else
			SHM=`grep 666 /proc/sysvipc/shm`
			if [ -n "$SHM" ]; then
				BYTES=`echo $SHM | cut -d ' ' -f 4`
				echo "Transferred $BYTES bytes in $DELTA seconds"
			fi
			echo "Writing $BYTES bytes to flash"
            echo "Stop" >/tmp/nocachegen
            /usr/bin/marktime.sh &
            export MARKTIMEPID=$!
			RESULT=`flash_util -f $FILE`
            echo '<!--'
            kill $MARKTIMEPID
            sleep 1
            sleep 1
            echo ' > '
            rm -f /tmp/nocachegen
			if [ "$RESULT" = "OK" ]; then
				echo "Verifying flash"
                /usr/bin/marktime.sh &
                export MARKTIMEPID=$!
				RESULT=`flash_util -v $FILE`
            echo '<!--'
                kill $MARKTIMEPID
            sleep 1
            sleep 1
            echo ' > '
				if [ "$RESULT" = "OK" ]; then
					echo "Verified $BYTES bytes OK"
					RESULT="<b>Firmware installed successfully</b>"
					FAIL="Installed firmware will be activated at the next reboot"
				else
					RESULT="Flash verify failed!"
				fi
            else
                echo 'Result was $RESULT, retry download<br>'
			fi
		fi
	fi
	if [ "$DEST" = "+" ]; then
		qt flash_util -x
	fi
	#echo "5,$$" >/var/run/Status.clear
    setstat -d 0 -c $STATUS
	unlock boot

    export QUERY_STRING="action=Wake"
    TEMP=`aisg_command`
    sleep 2

echo $RESULT
echo
echo $FAIL
cat <<EOF
</pre>
<a href="/cgi-bin/atc300SoftwareConfig.cgi">Back</a>
EOF
if [ -z "$logOper" ]; then
    cat menubar.html
else 
  if [ "$logOper" = "10" ]; then
    cat menubar_admin.html
  else
    cat menubar_oper.html
  fi
fi
cat <<EOF
</body>
</html>
EOF

