#!/bin/sh

ARGC=1
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiDevFuncs.sh
BACKLINK="/cgi-bin/device.cgi?action=Command&subset=$subset&name=$name"
./header.sh "Device Set Data"

ANTCOLOUR="#6699CC"
TMACOLOUR="#6699CC"
OPERCOLOUR="#6699CC"

case "$ftype" in
	Antenna) ANTCOLOUR="#012fcb" ;;
	TMA) TMACOLOUR="#012fcb" ;;
	Operator) OPERCOLOUR="#012fcb" ;;
esac


if [ "$action" != "Command" ]; then
TEMP=`/usr/bin/aisg_command -l -b "<tr><td>" -e "</td></tr>" -s "</td><td>"`
fi

cat <<EOF
<table border=0 cellspacing=0 cellpadding=0 width=680 align=center summary="">
	<tr>
		<td valign=top>
			<table border=0 cellspacing=0 cellpadding=4 width=100 height=480 summary="Main menu">
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/index.cgi" class=menu>Main Page</a></td>
				</tr>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/oldindex.cgi" class=menu>Old Main Page</a></td>
				</tr>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/status.cgi?subset=Device">&#149;&nbsp;Site Status</A>
					</TD>
				</TR>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/status.cgi?subset=$subset" class=menu>&nbsp;&nbsp;&#150;&nbsp;$subset View</a></td>
				</tr>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="$BACKLINK" class=menu>&nbsp;&nbsp;&#151;&nbsp;$subset Command</a></td>
				</tr>
				<tr>
					<td bgcolor=$ANTCOLOUR nowrap><a href="sdd.cgi?ftype=Antenna&action=Command&subset=$subset&name=$name" class=menu>&nbsp;&nbsp;&#151;&nbsp;Set Data [Antenna]</a></td>
				</tr>
				<tr>
					<td bgcolor=$TMACOLOUR nowrap><a href="sdd.cgi?ftype=TMA&action=Command&subset=$subset&name=$name" class=menu>&nbsp;&nbsp;&#151;&nbsp;Set Data [TMA]</a></td>
				</tr>
				<tr>
					<td bgcolor=$OPERCOLOUR nowrap><a href="sdd.cgi?ftype=Operator&action=Command&subset=$subset&name=$name" class=menu>&nbsp;&nbsp;&#151;&nbsp;Set Data [Operator]</a></td>
				</tr>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/system.cgi">&#149;&nbsp;$UNIT Configuration</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC height="100%">
						<PRE> </PRE>
					</TD>
				</TR>
			</table>
		</td>
		<td align=center width=12></td>
		<td valign=top align=left>
EOF

NAME=`xlate $name`
if [ "$subset" = "Device" ]; then
	if [ "$name" = "All" ]; then
		BANNER="$subset $name"
	else
		BANNER="$subset `devname $name`"
	fi
else
	BANNER="$subset $NAME"
fi

		cat <<-EOF
		<table border=0 width=530 cellspacing=0 cellpadding=0>
		<tr><td align=center >Set $ftype Data - $BANNER</td></tr>
		</table>
		<hr>
		<table border=2 cellspacing=0 cellpadding=4>
		<form  action="/cgi-bin/sdd.cgi" method=GET ONSUBMIT="return validateForm(this)">
		<tr>
			<td>Data Field:</td>
			<td>Data Type:</td>
			<td>Data Parameter:</td>
		</tr>
		`typetable -f $ftype -n $name`
		<tr>
			<td><input type=submit name="action" value="Set Device Data" class=button style="width: 110px"> </td>
			<td>&nbsp</td>
			<td>&nbsp</td>
		</tr>
		<input type=hidden name="ftype" value="$ftype">
		<input type=hidden name="command" value="14">
		<input type=hidden name="subset" value="$subset">
		<input type=hidden name="name" value="$NAME">
		</form></table>
		<hr>
		EOF
	
if [ "$action" != "Command" ]; then

		cat <<-EOF
			<table border=0 cellspacing=0 cellpadding=0>
				<tr>
					<td><H3>AISG Command</H3></td>
				</tr>
			</table>
			<table border=2 cellspacing=0 cellpadding=4>
			<tr>
				<td><H4>Device</H4></td><td><H4>Command</H4></td><td colspan=10><H4>Result</H4></td>
			</tr>
			$TEMP
			</table>
		EOF
		echo "<hr>"
fi
cat <<EOF
		</td>
	</tr>
</table>
</body>
</html>
EOF
