#!/bin/sh

BACKLINK=$HTTP_REFERER
ARGC=1
. ./getargs.sh
. ./cgiComFuncs.sh
date=`date -u '+%a, %d %b %Y %H:%M:%S %Z'`
SITE=`ascu_db_trans -db Site.db -f 1 | cut -f 2`
DEVCOLOUR="#6699CC"
SECCOLOUR="#6699CC"
GRPCOLOUR="#6699CC"
BANCOLOUR="#6699CC"

if [ "$action" = "Wake" ]; then
    aisg_command -v
    subset=Device
fi

case "$subset" in
	Device) DEVCOLOUR="#012fcb" ;;
	Sector) SECCOLOUR="#012fcb" ;;
	Group) GRPCOLOUR="#012fcb" ;;
	Band) BANCOLOUR="#012fcb" ;;
esac


./header.sh "$subset Status"

cat <<EOF
<TABLE align=center border=0 cellPadding=0 cellSpacing=0 width=900 summary="">
<TBODY>
	<TR>
		<TD valign=top>
			<TABLE border=0 cellPadding=4 cellSpacing=0 height=380 width=100 summary="Main menu">
			<TBODY>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/index.cgi" class=menu>Main Page</a></td>
				</tr>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/oldindex.cgi" class=menu>Old Main Page</a></td>
				</tr>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/status.cgi?subset=Device">&#149;&nbsp;Antenna Devices</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=$DEVCOLOUR noWrap>
						<A class=menu href="/cgi-bin/status.cgi?subset=Device">&nbsp;&nbsp;&#150;&nbsp;Device View</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=$SECCOLOUR noWrap>
						<A class=menu href="/cgi-bin/status.cgi?subset=Sector">&nbsp;&nbsp;&#150;&nbsp;Sector View</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/system.cgi">&#149;&nbsp;Controller</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC height="100%">
						<PRE> </PRE>
					</TD>
				</TR>
			</TBODY>
			</TABLE>
		</TD>
		<TD align=middle width=12></TD>
		<TD align=left vAlign=top>
EOF

FWIDTH=12
cat <<EOF
			<TABLE width="830" summary="" border=0 cellpadding=2>
			<TBODY>
				<TR>
					<TD align=center colspan="$FWIDTH"><H2>$SITE</H2> Summary Table generated at $date</TD>
				</TR>
EOF
if [ -f /tmp/hibernate.txt ]; then
cat <<EOF
                </TR>
                    <TD align=center colspan="$FWIDTH"><B>NOTE: Actuator bus is currently in standby.</B>
                        <form  action="/cgi-bin/status.cgi" method=GET><input type=submit name ="action" value="Wake" class=button ></form>
                    </TD>
                </TR>
EOF
else if [ "$action" = "Wake" ]; then
cat <<EOF
                </TR>
                    <TD align=center colspan="$FWIDTH">Actuator bus awakened.</TD>
                </TR>
EOF
  fi
fi
cat <<EOF
  <style type="text/css">
    div#scrollArea {height: 155px; width: 830px; border: 0px solid #012fcb; background: #FFFFFF;
    text-align: center; padding: 10px; margin: 0px; overflow: auto}
  </style>
			</TBODY>
			</TABLE>
            <TABLE width="815" summary="" border=0 cellpadding=2>            
			`statustable -s $subset -h`
            <TR><TD align=right>
EOF
if [ "$class" = "TMA" ]; then
cat <<EOF
        <A href="/cgi-bin/status.cgi?subset=Device&class=RET">Show RETs</A>
EOF
else
cat <<EOF
        <A href="/cgi-bin/status.cgi?subset=Device&class=TMA">Show TMAs</A>
EOF
fi
            
cat <<EOF
            </TD></TR>
			</TABLE>
            <TABLE border=2>
EOF
if [ "$class" = "TMA" ]; then
cat <<EOF
			`statustable -s $subset -l TMA`
EOF
else
cat <<EOF
			`statustable -s $subset -l RET`
EOF
fi
cat <<EOF
            </TABLE>
            
            <TABLE width="530" align=center>
            <tr><td>&nbsp;</td></tr>
            <tr>
            <td>&nbsp;</td>
            <td>
<form  action="/cgi-bin/finddev.cgi" method=GET><input type=submit value="Find Devices" class=button ></form>
            </td>
            <td>
<form  action="/cgi-bin/adddev.cgi" method=GET><input type=submit value="Add Devices Manually" class=button ></form>
            </td>
            <td>
<form  action="/cgi-bin/rmdev.cgi" method=GET><input type=submit value="Rename or Remove Devices" class=button ></form>
            </td>
            <td>
<form  action="/cgi-bin/support.cgi" method=GET><input type=submit value="Support Devices" class=button ></form>
            </td>
            </tr>
            </TABLE>
		</TD>
	</TR>
</TBODY>
</TABLE>
</BODY>
</HTML>
EOF
