#!/bin/sh

BACKLINK=$HTTP_REFERER
SITE=`ascu_db_trans -db Site.db -f 1 | cut -f 2`
ARGC=1
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiSysFuncs.sh

if [ -z "$action" ]; then
	RESULT=""
else
	case $action in
        Change+Name)
			if [ -z "$site" ]; then
				RESULT="Please enter a new name"
			else
				SITE=`xlate $site`
				ascu_db_trans -db Site.db -f 1 -w "1	$SITE"
				RESULT="Site name changed to $SITE"
			fi
	        ;;
		Set+Date+%26+Time)
			if [ -z "$minute" ]; then
				date -u "$year.$month.$day-$hour:$minuteten$minuteunit"
			else
				date -u "$year.$month.$day-$hour:$minute"
			fi
			hwclock -w
			RESULT="Date & Time adjusted"
			#resync actuators
			#QUERY_STRING="command=249&subset=Device&name=All"
			#qt aisg_command
			;;
		Set+Poll+Time)
			if [ "$poll" -gt 60000 ]; then
				poll=60000
			fi
			if [ "$poll" -lt 300 ]; then
				poll=300
			fi
			ascu_db_trans -db Site.db -f 5 -w "5	$poll"
			qt aisg_command
			RESULT="Poll time set to $poll ms"
			;;
		Set+IP+Address)
			if [ -z "$override" ]; then
				ascu_db_trans -db Site.db -f 6 -w "6	$ipaddr"
                                echo $ipaddr > /StaticIP.txt
			else
				ascu_db_trans -db Site.db -f 6 -w "6	$override"
                                echo $override > /StaticIP.txt
			fi
			save >>/dev/null
			RESULT="IP address will be updated at the next reboot"
			;;
		Set+IP+Details)
				RESULT="IP details will be updated at the next reboot"
				if [ -z "$ipaddr" ]; then
					RESULT="Error - please enter an IP address"
				else
					ascu_db_trans -db Site.db -f 6 -w "6	$ipaddr"
                                        echo $ipaddr > /StaticIP.txt
				fi
				ascu_db_trans -db Site.db -f 9 -w "9	$netmask"
                                echo $netmask > /NetMask.txt
				save >>/dev/null
				if [ -z "$router" ]; then
					ascu_db_trans -db Site.db -f 10 -r
					if [ -f /Route.txt ]; then
						rm /Route.txt
					fi
				else
					ascu_db_trans -db Site.db -f 10 -w "10	$router"
                                        echo $router > /Route.txt
 				fi
				if [ -z "$dnsaddr" ]; then
					ascu_db_trans -db Site.db -f 11 -r
				else
					ascu_db_trans -db Site.db -f 11 -w "11	$dnsaddr"
				fi
			;;
		Set+MAC+Address)
			ascu_db_trans -db Site.db -f 7 -w "7	$macaddr"
			RESULT="Ethernet MAC address will be updated at the next reboot"
			;;
	esac
fi

PTIME=`ascu_db_trans -db Site.db -f 5 | cut -f 2`
IPADDR=`getaddr 6`

VFORM='function validateForm(form) { // validate form data
  if (!(boundsvalidation(form.poll.value,60000,300)))
  {
    alert("Poll time must be between 300 and 60000")
    form.poll.focus()
    return false;
  }
  return true;
}'

export VFORM
./header.sh "System Configuration"

cat <<EOF
<table border=0 cellspacing=0 cellpadding=0 width=680 align=center summary="">
	<tr>
		<td valign=top>
			<table border=0 cellspacing=0 cellpadding=4 width=100 height=480 summary="Main menu">
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/index.cgi" class=menu>Main Page</a></td>
				</tr>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/oldindex.cgi" class=menu>Old Main Page</a></td>
				</tr>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/status.cgi?subset=Device">&#149;&nbsp;Antenna Devices</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/system.cgi">&#149;&nbsp;Controller</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#012fcb noWrap>
						<A class=menu href="/cgi-bin/system.cgi">&nbsp;&nbsp;&#150;&nbsp;Basic Configuration</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/service.cgi">&nbsp;&nbsp;&#150;&nbsp;Service Menu</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/secure/admin.cgi">&nbsp;&nbsp;&#150;&nbsp;Admin Menu</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC height="100%">
						<PRE> </PRE>
					</TD>
				</TR>
			</table>
		</td>
		<td align=center width=12></td>
		<td valign=top align=left>
      		<table border=0 width=600 cellspacing=0 cellpadding=0 summary="">
      			<tr>
      				<td><H3>$UNIT Configuration</H3></td>
      			</tr>
      		</table>
      		<table border=0 cellspacing=0 width=600>
      			<form  action="/cgi-bin/system.cgi" method=GET>
      				<tr>
      					<td>Site Name: </td>
      					<td><input type="text" name="site" size="25" value="$SITE"></td>
      					<td align=right><input type=submit name="action" value="Change Name" class=button style="width: 100px"></td>
      				</tr>
      			</form>
				<form  action="/cgi-bin/system.cgi" method=GET ONSUBMIT="return validateForm(this)">
EOF
#				<tr>
#                    <td>Poll Time: </td>
#					<td align=right><input type=submit name ="action" value="Set Poll Time" class=button style="width: 100px"></td>
#				</tr>
cat <<EOF
				</form>
      		</table>
            <br><hr><br>
EOF

NETMASK=`getaddr 9`
ROUTER=`getaddr 10`
DNSADDR=`getaddr 11`

cat <<-EOF
		<table border=0 cellspacing=0 width=600>
			<form  action="/cgi-bin/system.cgi" method=GET>
			<tr>
				<td>IP address:</td>
				<td><input type="text" name="ipaddr" size="16" value="$IPADDR"></td>
				<td>Netmask: </td>
				<td align=right><input type="text" name="netmask" size="16" value="$NETMASK"></td>
			</tr>
			<tr>
				<td>Default router:</td>
				<td><input type="text" name="router" size="16" value="$ROUTER"></td>
				<td>Domain name server:</td>
				<td align=right><input type="text" name="dnsaddr" size="16" value="$DNSADDR"></td>
			</tr>
			<tr>
				<td>Use DHCP</td>
				<td align=center><input type="checkbox" name="dhcp" $DHCP></td>
				<td>&nbsp;</td>
				<td align=right><input type=submit name ="action" value="Set IP Details" class=button style="width: 100px" align=right></td>
			</tr>
			</form>
		</table>
	<br><hr><br>
EOF

  datetable $TARGET
cat <<EOF
            <br><hr><br>
			<form  action="/cgi-bin/atc300Upload.cgi" method=GET>
			<table border=0 cellspacing=0 cellpadding=0 width=600>
				<tr>
					<td>Firmware&nbsp;URL:&nbsp;ftp://</td>
					<td colspan=3><input type="text" name="url" size="74" value="$URL1" width="300px"></td>
				</tr>
				<tr>
   				<td>Username:</td>
				<td><input type="text" name="username" size="28" value="$username"></td>
				<td>Password:</td>
				<td align=right><input type="password" name="password" size="22" value="$password"></td>
				</tr>
				<tr>
                    <td>&nbsp;</td>
					<td><input type=submit name ="action" value="Install System Firmware" class=button></td>
                    <td>&nbsp;</td>
					<td align=right><input type=submit name ="action" value="Clear Stale Lock" class=button></td>
                </tr>
            </table>
            <br><hr><br>            
			<table border=0 cellspacing=0 cellpadding=0 width=600>
                <tr>
					<td align=center><input type=submit name ="action" value="Reboot" class=button></td>
				</tr>
			</table>
			</form>
			<table>
				<tr>
					<td>$RESULT</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</body>
</html>
EOF

