#!/bin/sh

BACKLINK=$HTTP_REFERER
ARGC=1
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiSysFuncs.sh

if [ -z "$action" ]; then
	RESULT=""
else
	case $action in
		Set+Date+%26+Time)
			if [ -z "$minute" ]; then
				date -u "$year.$month.$day-$hour:$minuteten$minuteunit"
			else
				date -u "$year.$month.$day-$hour:$minute"
			fi
			hwclock -w
			RESULT="Date & Time adjusted"
			#resync actuators
			#QUERY_STRING="command=249&subset=Device&name=All"
			#qt aisg_command
			;;
		Set+Poll+Time)
			if [ "$poll" -gt 60000 ]; then
				poll=60000
			fi
			if [ "$poll" -lt 300 ]; then
				poll=300
			fi
			ascu_db_trans -db Site.db -f 5 -w "5	$poll"
			qt aisg_command
			RESULT="Poll time set to $poll ms"
			;;
		Set+IP+Address)
			if [ -z "$override" ]; then
				ascu_db_trans -db Site.db -f 6 -w "6	$ipaddr"
                                echo $ipaddr > /StaticIP.txt
			else
				ascu_db_trans -db Site.db -f 6 -w "6	$override"
                                echo $override > /StaticIP.txt
			fi
			save >>/dev/null
			RESULT="IP address will be updated at the next reboot"
			;;
		Set+IP+Details)
				RESULT="IP details will be updated at the next reboot"
				if [ -z "$ipaddr" ]; then
					RESULT="Error - please enter an IP address"
				else
					ascu_db_trans -db Site.db -f 6 -w "6	$ipaddr"
                                        echo $ipaddr > /StaticIP.txt
				fi
				ascu_db_trans -db Site.db -f 9 -w "9	$netmask"
                                echo $netmask > /NetMask.txt
				save >>/dev/null
				if [ -z "$router" ]; then
					ascu_db_trans -db Site.db -f 10 -r
					if [ -f /Route.txt ]; then
						rm /Route.txt
					fi
				else
					ascu_db_trans -db Site.db -f 10 -w "10	$router"
					echo $router > /Route.txt
				fi
				if [ -z "$dnsaddr" ]; then
					ascu_db_trans -db Site.db -f 11 -r
				else
					ascu_db_trans -db Site.db -f 11 -w "11	$dnsaddr"
				fi
			;;
		Set+MAC+Address)
			ascu_db_trans -db Site.db -f 7 -w "7	$macaddr"
			RESULT="Ethernet MAC address will be updated at the next reboot"
			;;
	esac
fi

PTIME=`ascu_db_trans -db Site.db -f 5 | cut -f 2`
IPADDR=`getaddr 6`

VFORM='function validateForm(form) { // validate form data
  if (!(boundsvalidation(form.poll.value,60000,300)))
  {
    alert("Poll time must be between 300 and 60000")
    form.poll.focus()
    return false;
  }
  return true;
}'

export VFORM
./header.sh "System Configuration"

cat <<EOF
<table border=0 cellspacing=0 cellpadding=0 width=680 align=center summary="">
	<tr>
		<td valign=top>
			<table border=0 cellspacing=0 cellpadding=4 width=100 height=480 summary="Main menu">
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/index.cgi" class=menu>Main Page</a></td>
				</tr>
				<tr>
					<td bgcolor=#6699CC nowrap><a href="/cgi-bin/oldindex.cgi" class=menu>Old Main Page</a></td>
				</tr>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/status.cgi?subset=Device">&#149;&nbsp;Site Status</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/site.cgi">&#149;&nbsp;Site Configuration</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/system.cgi">&#149;&nbsp;$UNIT Configuration</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#012fcb noWrap>
						<A class=menu href="/cgi-bin/system.cgi">&nbsp;&nbsp;&#150;&nbsp;Basic Configuration</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/service.cgi">&nbsp;&nbsp;&#150;&nbsp;Service Menu</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC noWrap>
						<A class=menu href="/cgi-bin/secure/admin.cgi">&nbsp;&nbsp;&#150;&nbsp;Admin Menu</A>
					</TD>
				</TR>
				<TR>
					<TD bgColor=#6699CC height="100%">
						<PRE> </PRE>
					</TD>
				</TR>
			</table>
		</td>
		<td align=center width=12></td>
		<td valign=top align=left>
			<table border=0 width=530 cellspacing=0 cellpadding=4>
				<tr>
					<td><H3>$UNIT Configuration</H3></td>
				</tr>
			</table>
			<hr>
EOF

if [ "$TARGET" = "NOKIA" ]; then
	MACFLAG=`ascu_db_trans -db Site.db -f 7 | cut -f 2`
	if [ -z "$IPADDR" ]; then
		IPFLAG=`ascu_db_trans -db Site.db -f 6 | cut -f 2`
	fi
	if [ "$IPFLAG" = 0 ]; then
		IP0="selected"
		IP1=""
	else
		IP0=""
		IP1="selected"
	fi
	if [ "$MACFLAG" = 0 ]; then
		MAC0="selected"
		MAC1=""
	else
		MAC0=""
		MAC1="selected"
	fi
	cat <<-EOF
			<table border=0 cellspacing=0 cellpadding=4>
				<form  action="/cgi-bin/system.cgi" method=GET>
				<tr>
					<td><input type=submit name ="action" value="Set MAC Address" class=button style="width: 100px"></td>
					<td>
						<select name=macaddr>
							<option value=0 $MAC0>0E 00 00 02 01 02</option>
							<option value=1 $MAC1>0E 00 00 02 01 03</option>
						</select>
					</td>
				</tr>
				</form>
				<form  action="/cgi-bin/system.cgi" method=GET>
				<tr>
					<td><input type=submit name ="action" value="Set IP Address" class=button style="width: 100px"></td>
					<td>
						<select name=ipaddr>
							<option value=0 $IP0>192.168.255.141</option>
							<option value=1 $IP1>192.168.255.142</option>
						</select>
					</td>
					<td>Demo IP address <input type="text" name="override" size="16" value="$IPADDR"></td>
				</tr>
				</form>
	EOF
else
	NETMASK=`getaddr 9`
	ROUTER=`getaddr 10`
	DNSADDR=`getaddr 11`

	cat <<-EOF
			<table border=0 cellspacing=0 cellpadding=4>
				<form  action="/cgi-bin/system.cgi" method=GET>
				<tr>
					<td>Use DHCP</td>
					<td>IP address</td>
					<td>Netmask </td>
				</tr>
				<tr>
					<td align=center><input type="checkbox" name="dhcp" $DHCP></td>
					<td><input type="text" name="ipaddr" size="16" value="$IPADDR"></td>
					<td><input type="text" name="netmask" size="16" value="$NETMASK"></td>
				</tr>
				<tr>
					<td></td>
					<td>Default router</td>
					<td>Domain name server</td>
				</tr>
				<tr>
					<td><input type=submit name ="action" value="Set IP Details" class=button style="width: 100px"></td>
					<td><input type="text" name="router" size="16" value="$ROUTER"></td>
					<td><input type="text" name="dnsaddr" size="16" value="$DNSADDR"></td>
				</tr>
				</form>
	EOF
fi
cat <<EOF
				<form  action="/cgi-bin/system.cgi" method=GET ONSUBMIT="return validateForm(this)">
				<tr>
					<td><input type=submit name ="action" value="Set Poll Time" class=button style="width: 100px"></td>
					<td><input type="text" name="poll" size="6" value="$PTIME"> ms</td>
				</tr>
				</form>
				<form  action="/cgi-bin/upload.cgi" method=GET>
				<tr>
					<td><input type=submit name ="action" value="Reboot" class=button style="width: 100px"></td>
				</tr>
				</form>
			</table>
			<hr>
EOF
  datetable $TARGET
cat <<EOF
			<hr>
			<form  action="/cgi-bin/upload.cgi" method=GET>
			<table border=0 cellspacing=0 cellpadding=4>
				<tr>
					<td>Firmware URL</td>
				</tr>
				<tr>
					<td>ftp://<input type="text" name="url" size="48" value="$URL1"></td>
				</tr>
			</table>
			<table border=0 cellspacing=0 cellpadding=4>
				<tr>
					<td>Username</td>
					<td>Password</td>
				</tr>
				<tr>
					<td><input type="text" name="username" size="32" value="$username"></td>
					<td><input type="password" name="password" size="32" value="$password"></td>
				</tr>
				<tr>
					<td><input type=submit name ="action" value="Install System Firmware" class=button></td>
					<td><input type=submit name ="action" value="Clear Stale Lock" class=button></td>
				</tr>
			</table>
			</form>
			<hr>
			<form  action="/cgi-bin/upload2.cgi" enctype="multipart/form-data" method=POST>
			<table border=0 cellspacing=0 cellpadding=4>
				<tr>
					<td>Firmware Point-and-Shoot</td>
				</tr>
				<tr>
					<td><input type="file" name="file" size="48" value="$URL1" accept="*.ascu"></td>
				</tr>
			</table>
			<table border=0 cellspacing=0 cellpadding=4>
				<tr>
					<td><input type=submit name ="action" value="Post File from Firmware" class=button></td>
				</tr>
			</table>
			</form>


            <table>
				<tr>
					<td>$RESULT</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</body>
</html>
EOF

