#!/bin/sh

BACKLINK=$HTTP_REFERER
ARGC=1
. ./getargs.sh
. ./cgiComFuncs.sh
. ./cgiSysFuncs.sh
if [ -z "$action" ]; then
	RESULT=""
else
	case $action in
		Install+System+Firmware)
			BUSY=`syslock boot $REMOTE_ADDR`
			if [ -z "$BUSY" ]; then
				TITLE="System Firmware Upload"
				if [ -z "$url" ]; then
					RESULT="A valid URL for the firmware file must be provided"
				else
					URL1=`echo $url | sed "s/%3A/:/g;s/%2F/\//g"`
					URL=`echo $URL1 | sed "s/ftp:\/\///"`
					ADDR=`echo $URL | sed "s@/.*@@"`
					FILE=`basename $URL`
					ULTYPE=`echo $FILE | sed "s/.......//;s/_.*//"`
					if [ "$ULTYPE" = "AT" ]; then
						DEST="/tmp/Antenna.db"
					else
						DEST="+"
					fi
					if [ "$TARGET" = "ANDREW" -o `echo $ADDR | sed "s/[0-9]//g"` = "..." ]; then
						if [ -z `echo $FILE | sed -n "/.*.ascu\$/p"` ]; then
							URL=""
						else
							if [ -n "$username" ]; then
								USER="$username:$password@"
							else
								USER=""
							fi
						fi
					else
						URL=""
						RESULT="$ADDR: Only dotted-decimal addresses are supported"
					fi
				fi
			else
				RESULT="Unable to install firmware"
				FAIL="Installation lock held by $BUSY"
			fi
			;;
		Reboot)
			IPADDR=`cat /StaticIP.txt`
			BUSY=`syslock boot $REMOTE_ADDR`
			if [ -z "$BUSY" ]; then
				TITLE="System Reboot"
				#echo > /var/run/reboot
				RESULT="Rebooting - please wait"
				FAIL="Reboot in approx 60 seconds"
				PORT=80
				if [ -z "$IPADDR" ]; then
					REFR="/cgi-bin/index.cgi"
				else
					REFR="http://$IPADDR:$PORT/cgi-bin/index.cgi"
				fi
				export META="<META HTTP-EQUIV=REFRESH CONTENT=\"65; URL=$REFR\">"
				fastboot.sh &
			else
				RESULT="Unable to reboot"
				FAIL="Firmware installation lock held by by $BUSY"
			fi
			;;
		Clear+Stale+Lock)
			TITLE="Clear Lock"
			if [ -f /var/lock/boot ]; then
				RESULT="Lock held by `cat /var/lock/boot`"
				unlock boot
				FAIL="Lock cleared"
			else
				RESULT="No stale lock found"
				FAIL=" "
			fi
			;;
	esac
fi

./header.sh $TITLE

echo "<pre>"
if [ -z "$FAIL" ]; then
	FAIL="Firmware installation was unsuccessful"
fi
if [ -z "$URL" ]; then
	if [ -z "$RESULT" ]; then
		RESULT="A valid URL for the firmware file must be provided"
	fi
	if [ -z "$BUSY" ]; then
		unlock boot
	fi
else
	START=`date +%s`
	STATUS=`ascu_db_trans -db Error.db -f "	DOWNLOAD_STATUS" | cut -f 1`
	#echo "5,$$" >/var/run/Status.set
	setstat -d 0 -s $STATUS
	echo "Transferring firmware from ftp://$URL"
	RESULT=`wget -O $DEST ftp://$USER$URL 2>&1`
	if [ $? = 0 ]; then
		let DELTA=`date +%s`-$START
		if [ "$ULTYPE" = "AT" ]; then
			if [ -f "$DEST" ]; then
				BYTES=`ls -l $DEST | sed "s/  */	/g" | cut -f 5`
				echo "Transferred $BYTES bytes in $DELTA seconds"
				mv $DEST /var/ascu
				echo -n > /var/run/Dirty.db
				RESULT="<b>Antenna table installed successfully</b>"
				FAIL=""
			else
				FAIL="Antenna table installation was unsuccessful"
			fi
		else
			SHM=`grep 666 /proc/sysvipc/shm`
			if [ -n "$SHM" ]; then
				BYTES=`echo $SHM | cut -d ' ' -f 4`
				echo "Transferred $BYTES bytes in $DELTA seconds"
			fi
			echo "Writing $BYTES bytes to flash"
            /usr/bin/marktime.sh &
            export MARKTIMEPID=$!
			RESULT=`flash_util -f $FILE`
            kill $!
            echo " "
			if [ "$RESULT" = "OK" ]; then
				echo "Verifying flash"
                /usr/bin/marktime.sh &
                export MARKTIMEPID=$!
				RESULT=`flash_util -v $FILE`
                kill $!
                echo " "
				if [ "$RESULT" = "OK" ]; then
					echo "Verified $BYTES bytes OK"
					RESULT="<b>Firmware installed successfully</b>"
					FAIL="Installed firmware will be activated at the next reboot"
				else
					RESULT="Flash verify failed!"
				fi
			fi
		fi
	fi
	setstat -d 0 -c $STATUS
	unlock boot
fi
echo $RESULT
echo
echo $FAIL
cat <<EOF
</pre>
<a href="/cgi-bin/system.cgi">Back</a>
</body>
</html>
EOF
